{*******************************************************************************

  FILE: _AUReg.pas - AutoUpgrader Registration and Property Editors.

  Copyright (c) 1999-2001 UtilMind Solutions
  All rights reserved.
  E-Mail: info@utilmind.com
  WWW: http://www.utilmind.com, http://www.appcontrols.com

  The entire contents of this file is protected by International Copyright
Laws. Unauthorized reproduction, reverse-engineering, and distribution of all
or any portion of the code contained in this file is strictly prohibited and
may result in severe civil and criminal penalties and will be prosecuted to
the maximum extent possible under the law.

  Restrictions

  The source code contained within this file and all related files or any
portion of its contents shall at no time be copied, transferred, sold,
distributed, or otherwise made available to other individuals without express
written consent and permission from the UtilMind Solutions.

  Consult the End User License Agreement (EULA) for information on additional
restrictions.

*******************************************************************************}
{$I auDefines.inc}


unit _AUReg;

interface

procedure Register;

implementation


uses Windows, Classes, Controls, Forms,
     {$IFDEF D6}
     DesignIntf, DesignEditors,
     {$ELSE}
     DsgnIntf,
     {$ENDIF}
     AutoUpgrader, AutoUpgraderEditor;

type
{*******************************************************************************
  VersionInfo/Upgrade Message PROPERTY editor for AugoUpgrader
*******************************************************************************}
 { TAutoUpgraderProperty }
  TAutoUpgraderProperty = class(TClassProperty)
  public
    function GetValue: String; override;
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

{*******************************************************************************
  VersionInfo/Upgrade Message COMPONENT editor for AugoUpgrader
*******************************************************************************}
 { TauAutoUpgraderCompEditor }
  TauAutoUpgraderCompEditor = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
  end;

{ *** implementation for property editors *** }


{ TauAutoUpgraderProperty Editor }
function TAutoUpgraderProperty.GetValue: String;
begin
  Result := '(Upgrade Info)';
end;

function TAutoUpgraderProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paSubProperties, paDialog];
end;

procedure TAutoUpgraderProperty.Edit;
begin
  ShowAutoUpgraderDesigner(Designer, TAutoUpgrader(GetComponent(0)));
end;


{ TauAutoUpgraderCompEditor }
procedure TauAutoUpgraderCompEditor.ExecuteVerb(Index: Integer);
begin
  if Index = GetVerbCount - 1 then
    ShowAutoUpgraderDesigner(Designer, TAutoUpgrader(Component))
  else inherited ExecuteVerb(Index);
end;

function TauAutoUpgraderCompEditor.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + 1;
end;

function TauAutoUpgraderCompEditor.GetVerb(Index: Integer): String;
begin
  if Index = GetVerbCount - 1 then
    Result := '&Edit Info-file...'
  else
    Result := inherited GetVerb(Index);
end;

procedure Register;
begin
  RegisterComponents('UtilMind', [TAutoUpgrader]);
  RegisterComponentEditor(TAutoUpgrader, TauAutoUpgraderCompEditor);
  RegisterPropertyEditor(TypeInfo(TAutoUpgraderInfo), TAutoUpgrader, 'InfoFile', TAutoUpgraderProperty);
end;

end.
